using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace NengaSharp
{
	/// <summary>
	/// IԍҏW_CAOłB
	/// </summary>
	public class NumberEditDialog : System.Windows.Forms.Form
	{
		/// <summary>
		/// Iԍi[t@C
		/// </summary>
		private const string DATA_FILE_NAME = "numbers.csv";

		/// <summary>
		/// eEBhE
		/// </summary>
		private MainWindow parent;

		private System.Windows.Forms.TextBox rank1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox number1;
		private System.Windows.Forms.TextBox rank2;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox number2;
		private System.Windows.Forms.TextBox rank3;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox number3;
		private System.Windows.Forms.TextBox rank4;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox number4;
		private System.Windows.Forms.TextBox rank5;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox number5;
		private System.Windows.Forms.TextBox rank6;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox number6;
		private System.Windows.Forms.TextBox rank7;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox number7;
		private System.Windows.Forms.TextBox rank8;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.TextBox number8;
		private System.Windows.Forms.TextBox rank9;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox number9;
		private System.Windows.Forms.TextBox rank10;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.TextBox number10;
		private System.Windows.Forms.TextBox rank11;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox number11;
		private System.Windows.Forms.TextBox rank12;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TextBox number12;
		private System.Windows.Forms.TextBox rank13;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.TextBox number13;
		private System.Windows.Forms.TextBox rank14;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox number14;
		private System.Windows.Forms.TextBox rank15;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.TextBox number15;
		private System.Windows.Forms.TextBox rank16;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox number16;
		private System.Windows.Forms.TextBox rank17;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox number17;
		private System.Windows.Forms.TextBox rank18;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.TextBox number18;
		private System.Windows.Forms.TextBox rank19;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.TextBox number19;
		private System.Windows.Forms.TextBox rank20;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.TextBox number20;
		private System.Windows.Forms.Button saveButton;
		private System.Windows.Forms.Button cancelButton;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		private ArrayList rankBoxes = new ArrayList();
		private System.Windows.Forms.Button allClearButton;
		private ArrayList numberBoxes = new ArrayList();

		public NumberEditDialog(MainWindow parent)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			this.parent = parent;

			rankBoxes.Add(rank1);
			rankBoxes.Add(rank2);
			rankBoxes.Add(rank3);
			rankBoxes.Add(rank4);
			rankBoxes.Add(rank5);
			rankBoxes.Add(rank6);
			rankBoxes.Add(rank7);
			rankBoxes.Add(rank8);
			rankBoxes.Add(rank9);
			rankBoxes.Add(rank10);
			rankBoxes.Add(rank11);
			rankBoxes.Add(rank12);
			rankBoxes.Add(rank13);
			rankBoxes.Add(rank14);
			rankBoxes.Add(rank15);
			rankBoxes.Add(rank16);
			rankBoxes.Add(rank17);
			rankBoxes.Add(rank18);
			rankBoxes.Add(rank19);
			rankBoxes.Add(rank20);

			numberBoxes.Add(number1);
			numberBoxes.Add(number2);
			numberBoxes.Add(number3);
			numberBoxes.Add(number4);
			numberBoxes.Add(number5);
			numberBoxes.Add(number6);
			numberBoxes.Add(number7);
			numberBoxes.Add(number8);
			numberBoxes.Add(number9);
			numberBoxes.Add(number10);
			numberBoxes.Add(number11);
			numberBoxes.Add(number12);
			numberBoxes.Add(number13);
			numberBoxes.Add(number14);
			numberBoxes.Add(number15);
			numberBoxes.Add(number16);
			numberBoxes.Add(number17);
			numberBoxes.Add(number18);
			numberBoxes.Add(number19);
			numberBoxes.Add(number20);

			// Iԍf[^ǂݍ
			ReadNumberData();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(NumberEditDialog));
			this.rank1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.number1 = new System.Windows.Forms.TextBox();
			this.rank2 = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.number2 = new System.Windows.Forms.TextBox();
			this.rank3 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.number3 = new System.Windows.Forms.TextBox();
			this.rank4 = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.number4 = new System.Windows.Forms.TextBox();
			this.rank5 = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.number5 = new System.Windows.Forms.TextBox();
			this.rank6 = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.number6 = new System.Windows.Forms.TextBox();
			this.rank7 = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.number7 = new System.Windows.Forms.TextBox();
			this.rank8 = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.number8 = new System.Windows.Forms.TextBox();
			this.rank9 = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.number9 = new System.Windows.Forms.TextBox();
			this.rank10 = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.number10 = new System.Windows.Forms.TextBox();
			this.rank11 = new System.Windows.Forms.TextBox();
			this.label11 = new System.Windows.Forms.Label();
			this.number11 = new System.Windows.Forms.TextBox();
			this.rank12 = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.number12 = new System.Windows.Forms.TextBox();
			this.rank13 = new System.Windows.Forms.TextBox();
			this.label13 = new System.Windows.Forms.Label();
			this.number13 = new System.Windows.Forms.TextBox();
			this.rank14 = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.number14 = new System.Windows.Forms.TextBox();
			this.rank15 = new System.Windows.Forms.TextBox();
			this.label15 = new System.Windows.Forms.Label();
			this.number15 = new System.Windows.Forms.TextBox();
			this.rank16 = new System.Windows.Forms.TextBox();
			this.label16 = new System.Windows.Forms.Label();
			this.number16 = new System.Windows.Forms.TextBox();
			this.rank17 = new System.Windows.Forms.TextBox();
			this.label17 = new System.Windows.Forms.Label();
			this.number17 = new System.Windows.Forms.TextBox();
			this.rank18 = new System.Windows.Forms.TextBox();
			this.label18 = new System.Windows.Forms.Label();
			this.number18 = new System.Windows.Forms.TextBox();
			this.rank19 = new System.Windows.Forms.TextBox();
			this.label19 = new System.Windows.Forms.Label();
			this.number19 = new System.Windows.Forms.TextBox();
			this.rank20 = new System.Windows.Forms.TextBox();
			this.label20 = new System.Windows.Forms.Label();
			this.number20 = new System.Windows.Forms.TextBox();
			this.saveButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.allClearButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// rank1
			// 
			this.rank1.Location = new System.Drawing.Point(16, 16);
			this.rank1.MaxLength = 40;
			this.rank1.Name = "rank1";
			this.rank1.Size = new System.Drawing.Size(64, 19);
			this.rank1.TabIndex = 0;
			this.rank1.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(88, 17);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(16, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number1
			// 
			this.number1.Location = new System.Drawing.Point(112, 16);
			this.number1.MaxLength = 20;
			this.number1.Name = "number1";
			this.number1.TabIndex = 2;
			this.number1.Text = "";
			// 
			// rank2
			// 
			this.rank2.Location = new System.Drawing.Point(16, 48);
			this.rank2.MaxLength = 40;
			this.rank2.Name = "rank2";
			this.rank2.Size = new System.Drawing.Size(64, 19);
			this.rank2.TabIndex = 3;
			this.rank2.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(88, 46);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 23);
			this.label2.TabIndex = 4;
			this.label2.Text = "";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number2
			// 
			this.number2.Location = new System.Drawing.Point(112, 48);
			this.number2.MaxLength = 20;
			this.number2.Name = "number2";
			this.number2.TabIndex = 5;
			this.number2.Text = "";
			// 
			// rank3
			// 
			this.rank3.Location = new System.Drawing.Point(16, 80);
			this.rank3.MaxLength = 40;
			this.rank3.Name = "rank3";
			this.rank3.Size = new System.Drawing.Size(64, 19);
			this.rank3.TabIndex = 6;
			this.rank3.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(88, 78);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(16, 23);
			this.label3.TabIndex = 7;
			this.label3.Text = "";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number3
			// 
			this.number3.Location = new System.Drawing.Point(112, 80);
			this.number3.MaxLength = 20;
			this.number3.Name = "number3";
			this.number3.TabIndex = 8;
			this.number3.Text = "";
			// 
			// rank4
			// 
			this.rank4.Location = new System.Drawing.Point(16, 112);
			this.rank4.MaxLength = 40;
			this.rank4.Name = "rank4";
			this.rank4.Size = new System.Drawing.Size(64, 19);
			this.rank4.TabIndex = 9;
			this.rank4.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(88, 110);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(16, 23);
			this.label4.TabIndex = 10;
			this.label4.Text = "";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number4
			// 
			this.number4.Location = new System.Drawing.Point(112, 112);
			this.number4.MaxLength = 20;
			this.number4.Name = "number4";
			this.number4.TabIndex = 11;
			this.number4.Text = "";
			// 
			// rank5
			// 
			this.rank5.Location = new System.Drawing.Point(16, 144);
			this.rank5.MaxLength = 40;
			this.rank5.Name = "rank5";
			this.rank5.Size = new System.Drawing.Size(64, 19);
			this.rank5.TabIndex = 12;
			this.rank5.Text = "";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(88, 142);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(16, 23);
			this.label5.TabIndex = 13;
			this.label5.Text = "";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number5
			// 
			this.number5.Location = new System.Drawing.Point(112, 144);
			this.number5.MaxLength = 20;
			this.number5.Name = "number5";
			this.number5.TabIndex = 14;
			this.number5.Text = "";
			// 
			// rank6
			// 
			this.rank6.Location = new System.Drawing.Point(16, 176);
			this.rank6.MaxLength = 40;
			this.rank6.Name = "rank6";
			this.rank6.Size = new System.Drawing.Size(64, 19);
			this.rank6.TabIndex = 15;
			this.rank6.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(88, 174);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(16, 23);
			this.label6.TabIndex = 16;
			this.label6.Text = "";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number6
			// 
			this.number6.Location = new System.Drawing.Point(112, 176);
			this.number6.MaxLength = 20;
			this.number6.Name = "number6";
			this.number6.TabIndex = 17;
			this.number6.Text = "";
			// 
			// rank7
			// 
			this.rank7.Location = new System.Drawing.Point(16, 208);
			this.rank7.MaxLength = 40;
			this.rank7.Name = "rank7";
			this.rank7.Size = new System.Drawing.Size(64, 19);
			this.rank7.TabIndex = 18;
			this.rank7.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(88, 206);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(16, 23);
			this.label7.TabIndex = 19;
			this.label7.Text = "";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number7
			// 
			this.number7.Location = new System.Drawing.Point(112, 208);
			this.number7.MaxLength = 20;
			this.number7.Name = "number7";
			this.number7.TabIndex = 20;
			this.number7.Text = "";
			// 
			// rank8
			// 
			this.rank8.Location = new System.Drawing.Point(16, 240);
			this.rank8.MaxLength = 40;
			this.rank8.Name = "rank8";
			this.rank8.Size = new System.Drawing.Size(64, 19);
			this.rank8.TabIndex = 21;
			this.rank8.Text = "";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(88, 238);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(16, 23);
			this.label8.TabIndex = 22;
			this.label8.Text = "";
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number8
			// 
			this.number8.Location = new System.Drawing.Point(112, 240);
			this.number8.MaxLength = 20;
			this.number8.Name = "number8";
			this.number8.TabIndex = 23;
			this.number8.Text = "";
			// 
			// rank9
			// 
			this.rank9.Location = new System.Drawing.Point(16, 272);
			this.rank9.MaxLength = 40;
			this.rank9.Name = "rank9";
			this.rank9.Size = new System.Drawing.Size(64, 19);
			this.rank9.TabIndex = 24;
			this.rank9.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(88, 270);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(16, 23);
			this.label9.TabIndex = 25;
			this.label9.Text = "";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number9
			// 
			this.number9.Location = new System.Drawing.Point(112, 272);
			this.number9.MaxLength = 20;
			this.number9.Name = "number9";
			this.number9.TabIndex = 26;
			this.number9.Text = "";
			// 
			// rank10
			// 
			this.rank10.Location = new System.Drawing.Point(16, 304);
			this.rank10.MaxLength = 40;
			this.rank10.Name = "rank10";
			this.rank10.Size = new System.Drawing.Size(64, 19);
			this.rank10.TabIndex = 27;
			this.rank10.Text = "";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(88, 305);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(16, 16);
			this.label10.TabIndex = 28;
			this.label10.Text = "";
			this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number10
			// 
			this.number10.Location = new System.Drawing.Point(112, 304);
			this.number10.MaxLength = 20;
			this.number10.Name = "number10";
			this.number10.TabIndex = 29;
			this.number10.Text = "";
			// 
			// rank11
			// 
			this.rank11.Location = new System.Drawing.Point(256, 16);
			this.rank11.MaxLength = 40;
			this.rank11.Name = "rank11";
			this.rank11.Size = new System.Drawing.Size(64, 19);
			this.rank11.TabIndex = 30;
			this.rank11.Text = "";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(328, 14);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(16, 23);
			this.label11.TabIndex = 31;
			this.label11.Text = "";
			this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number11
			// 
			this.number11.Location = new System.Drawing.Point(352, 16);
			this.number11.MaxLength = 20;
			this.number11.Name = "number11";
			this.number11.TabIndex = 32;
			this.number11.Text = "";
			// 
			// rank12
			// 
			this.rank12.Location = new System.Drawing.Point(256, 48);
			this.rank12.MaxLength = 40;
			this.rank12.Name = "rank12";
			this.rank12.Size = new System.Drawing.Size(64, 19);
			this.rank12.TabIndex = 33;
			this.rank12.Text = "";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(328, 46);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(16, 23);
			this.label12.TabIndex = 34;
			this.label12.Text = "";
			this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number12
			// 
			this.number12.Location = new System.Drawing.Point(352, 48);
			this.number12.MaxLength = 20;
			this.number12.Name = "number12";
			this.number12.TabIndex = 35;
			this.number12.Text = "";
			// 
			// rank13
			// 
			this.rank13.Location = new System.Drawing.Point(256, 80);
			this.rank13.MaxLength = 40;
			this.rank13.Name = "rank13";
			this.rank13.Size = new System.Drawing.Size(64, 19);
			this.rank13.TabIndex = 36;
			this.rank13.Text = "";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(328, 78);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(16, 23);
			this.label13.TabIndex = 37;
			this.label13.Text = "";
			this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number13
			// 
			this.number13.Location = new System.Drawing.Point(352, 80);
			this.number13.MaxLength = 20;
			this.number13.Name = "number13";
			this.number13.TabIndex = 38;
			this.number13.Text = "";
			// 
			// rank14
			// 
			this.rank14.Location = new System.Drawing.Point(256, 112);
			this.rank14.MaxLength = 40;
			this.rank14.Name = "rank14";
			this.rank14.Size = new System.Drawing.Size(64, 19);
			this.rank14.TabIndex = 39;
			this.rank14.Text = "";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(328, 110);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(16, 23);
			this.label14.TabIndex = 40;
			this.label14.Text = "";
			this.label14.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number14
			// 
			this.number14.Location = new System.Drawing.Point(352, 112);
			this.number14.MaxLength = 20;
			this.number14.Name = "number14";
			this.number14.TabIndex = 41;
			this.number14.Text = "";
			// 
			// rank15
			// 
			this.rank15.Location = new System.Drawing.Point(256, 144);
			this.rank15.MaxLength = 40;
			this.rank15.Name = "rank15";
			this.rank15.Size = new System.Drawing.Size(64, 19);
			this.rank15.TabIndex = 42;
			this.rank15.Text = "";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(328, 142);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(16, 23);
			this.label15.TabIndex = 43;
			this.label15.Text = "";
			this.label15.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number15
			// 
			this.number15.Location = new System.Drawing.Point(352, 144);
			this.number15.MaxLength = 20;
			this.number15.Name = "number15";
			this.number15.TabIndex = 44;
			this.number15.Text = "";
			// 
			// rank16
			// 
			this.rank16.Location = new System.Drawing.Point(256, 176);
			this.rank16.MaxLength = 40;
			this.rank16.Name = "rank16";
			this.rank16.Size = new System.Drawing.Size(64, 19);
			this.rank16.TabIndex = 45;
			this.rank16.Text = "";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(328, 174);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(16, 23);
			this.label16.TabIndex = 46;
			this.label16.Text = "";
			this.label16.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number16
			// 
			this.number16.Location = new System.Drawing.Point(352, 176);
			this.number16.MaxLength = 20;
			this.number16.Name = "number16";
			this.number16.TabIndex = 47;
			this.number16.Text = "";
			// 
			// rank17
			// 
			this.rank17.Location = new System.Drawing.Point(256, 208);
			this.rank17.MaxLength = 40;
			this.rank17.Name = "rank17";
			this.rank17.Size = new System.Drawing.Size(64, 19);
			this.rank17.TabIndex = 48;
			this.rank17.Text = "";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(328, 206);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(16, 23);
			this.label17.TabIndex = 49;
			this.label17.Text = "";
			this.label17.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number17
			// 
			this.number17.Location = new System.Drawing.Point(352, 208);
			this.number17.MaxLength = 20;
			this.number17.Name = "number17";
			this.number17.TabIndex = 50;
			this.number17.Text = "";
			// 
			// rank18
			// 
			this.rank18.Location = new System.Drawing.Point(256, 240);
			this.rank18.MaxLength = 40;
			this.rank18.Name = "rank18";
			this.rank18.Size = new System.Drawing.Size(64, 19);
			this.rank18.TabIndex = 51;
			this.rank18.Text = "";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(328, 238);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(16, 23);
			this.label18.TabIndex = 52;
			this.label18.Text = "";
			this.label18.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number18
			// 
			this.number18.Location = new System.Drawing.Point(352, 240);
			this.number18.MaxLength = 20;
			this.number18.Name = "number18";
			this.number18.TabIndex = 53;
			this.number18.Text = "";
			// 
			// rank19
			// 
			this.rank19.Location = new System.Drawing.Point(256, 272);
			this.rank19.MaxLength = 40;
			this.rank19.Name = "rank19";
			this.rank19.Size = new System.Drawing.Size(64, 19);
			this.rank19.TabIndex = 54;
			this.rank19.Text = "";
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(328, 270);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(16, 23);
			this.label19.TabIndex = 55;
			this.label19.Text = "";
			this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number19
			// 
			this.number19.Location = new System.Drawing.Point(352, 272);
			this.number19.MaxLength = 20;
			this.number19.Name = "number19";
			this.number19.TabIndex = 56;
			this.number19.Text = "";
			// 
			// rank20
			// 
			this.rank20.Location = new System.Drawing.Point(256, 304);
			this.rank20.MaxLength = 40;
			this.rank20.Name = "rank20";
			this.rank20.Size = new System.Drawing.Size(64, 19);
			this.rank20.TabIndex = 57;
			this.rank20.Text = "";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(328, 302);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(16, 23);
			this.label20.TabIndex = 58;
			this.label20.Text = "";
			this.label20.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// number20
			// 
			this.number20.Location = new System.Drawing.Point(352, 304);
			this.number20.MaxLength = 20;
			this.number20.Name = "number20";
			this.number20.TabIndex = 59;
			this.number20.Text = "";
			// 
			// saveButton
			// 
			this.saveButton.Location = new System.Drawing.Point(472, 24);
			this.saveButton.Name = "saveButton";
			this.saveButton.TabIndex = 60;
			this.saveButton.Text = "ۑ";
			this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(472, 56);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 61;
			this.cancelButton.Text = "LZ";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// allClearButton
			// 
			this.allClearButton.Location = new System.Drawing.Point(472, 104);
			this.allClearButton.Name = "allClearButton";
			this.allClearButton.TabIndex = 63;
			this.allClearButton.Text = "ׂăNA";
			this.allClearButton.Click += new System.EventHandler(this.allClearButton_Click);
			// 
			// NumberEditDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(562, 344);
			this.Controls.Add(this.allClearButton);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.saveButton);
			this.Controls.Add(this.number20);
			this.Controls.Add(this.label20);
			this.Controls.Add(this.rank20);
			this.Controls.Add(this.number19);
			this.Controls.Add(this.label19);
			this.Controls.Add(this.rank19);
			this.Controls.Add(this.number18);
			this.Controls.Add(this.label18);
			this.Controls.Add(this.rank18);
			this.Controls.Add(this.number17);
			this.Controls.Add(this.label17);
			this.Controls.Add(this.rank17);
			this.Controls.Add(this.number16);
			this.Controls.Add(this.label16);
			this.Controls.Add(this.rank16);
			this.Controls.Add(this.number15);
			this.Controls.Add(this.label15);
			this.Controls.Add(this.rank15);
			this.Controls.Add(this.number14);
			this.Controls.Add(this.label14);
			this.Controls.Add(this.rank14);
			this.Controls.Add(this.number13);
			this.Controls.Add(this.label13);
			this.Controls.Add(this.rank13);
			this.Controls.Add(this.number12);
			this.Controls.Add(this.label12);
			this.Controls.Add(this.rank12);
			this.Controls.Add(this.number11);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.rank11);
			this.Controls.Add(this.number10);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.rank10);
			this.Controls.Add(this.number9);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.rank9);
			this.Controls.Add(this.number8);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.rank8);
			this.Controls.Add(this.number7);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.rank7);
			this.Controls.Add(this.number6);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.rank6);
			this.Controls.Add(this.number5);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.rank5);
			this.Controls.Add(this.number4);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.rank4);
			this.Controls.Add(this.number3);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.rank3);
			this.Controls.Add(this.number2);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.rank2);
			this.Controls.Add(this.number1);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.rank1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "NumberEditDialog";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "IԍҏW";
			this.Load += new System.EventHandler(this.NumberEditDialog_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// ̓Iԍʂ̓eōXV܂B
		/// </summary>
		public void UpdateLuckyNumbers()
		{
			// ̓Iԍ擾
			LuckyNumbers luckyNumbers = parent.GetLuckyNumbers();

			// NA
			luckyNumbers.ClearRankAndNumber();

			for(int i = 0; i < rankBoxes.Count; i++)
			{
				// ʂ̏擾
				TextBox rankBox = (TextBox)rankBoxes[i];
				TextBox numberBox = (TextBox)numberBoxes[i];

				if(rankBox.Text.Length > 0 && numberBox.Text.Length > 0)
				{
					// ɓo^
					luckyNumbers.AddRankAndNumber(
						new RankAndNumber(rankBox.Text, numberBox.Text));
				}
			}

			// Iԍ\[g
			luckyNumbers.Sort();
		}

		/// <summary>
		/// Iԍf[^t@Cɏ݂܂B
		/// </summary>
		private void WriteNumberData()
		{
			// ̓IԍXV{\[g
			UpdateLuckyNumbers();

			// ̓Iԍ擾
			LuckyNumbers luckyNumbers = parent.GetLuckyNumbers();

			string dataFilePath = Application.StartupPath + "\\" + DATA_FILE_NAME;

			StreamWriter writer = null;

			try
			{
				writer = new StreamWriter(
					dataFilePath, false, System.Text.Encoding.GetEncoding("shift_jis"));

				for(int i = 0; i < luckyNumbers.Count; i++)
				{
					RankAndNumber rankAndNumber = luckyNumbers.GetRankAndNumberOf(i);

					writer.WriteLine(rankAndNumber.Rank + "," + rankAndNumber.Number);
				}
			}
			catch(Exception e)
			{
				Debug.WriteLine(e.Message);
				Debug.WriteLine(e.StackTrace);
			}
			finally
			{
				if(writer != null)
				{
					writer.Close();
				}
			}
		}

		/// <summary>
		/// Iԍf[^t@Cǂݍ݂܂B
		/// </summary>
		private void ReadNumberData()
		{
			string dataFilePath = Application.StartupPath + "\\" + DATA_FILE_NAME;

			if(File.Exists(dataFilePath))
			{
				StreamReader reader = null;

				try
				{
					reader = new StreamReader(
						dataFilePath, System.Text.Encoding.GetEncoding("shift_jis"));

					Regex regex = new Regex("^[0-9]+$");

					int dataNumber = 0;

					string line;

					while((line = reader.ReadLine()) != null)
					{
						string[] data = line.Split(",".ToCharArray());

						// CSVf[^tH[}bgsȏꍇ
						if(data.Length != 2)
						{
							MessageBox.Show(
								"f[^t@C" + (dataNumber + 1)
								+ "Ԗڂ̃f[^tH[}bgłB\r\n"
								+ "ȍ~̃f[^ǂݍ݂XLbv܂B",
								"Nenga#",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

							return;
						}

						// ԍf[^ɐlȊO܂܂Ăꍇ
						if(! regex.IsMatch(data[1]))
						{
							MessageBox.Show(
								"f[^t@C" + (dataNumber + 1)
								+ "Ԗڂ̓IԍɐlȊO̕܂܂Ă܂B\r\n"
								+ "ȍ~̃f[^ǂݍ݂XLbv܂B",
								"Nenga#",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

							return;
						}

						((TextBox)rankBoxes[dataNumber]).Text = data[0];
						((TextBox)numberBoxes[dataNumber]).Text = data[1];

						dataNumber++;

						if(dataNumber >= 20)
						{
							break;
						}
					}
				}
				catch(Exception e)
				{
					Debug.WriteLine(e.Message);
					Debug.WriteLine(e.StackTrace);
				}
				finally
				{
					if(reader != null)
					{
						reader.Close();
					}
				}
			}
		}

		/// <summary>
		/// IԍɐlȊO͂Ă邩`FbN܂B
		/// </summary>
		/// <returns>lȊO͓͂Ăꍇtrue,łȂꍇfalse</returns>
		private bool HasIllegalNumber()
		{
			Regex regex = new Regex("^[0-9]+$");

			for(int i = 0; i < rankBoxes.Count; i++)
			{
				TextBox rankBox = (TextBox)rankBoxes[i];
				TextBox numberBox = (TextBox)numberBoxes[i];

				if(rankBox.Text.Length > 0 && numberBox.Text.Length > 0)
				{
					if(! regex.IsMatch(numberBox.Text))
					{
						return true;
					}
				}
			}

			return false;
		}

		/// <summary>
		/// IԍҏWʃ[h̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void NumberEditDialog_Load(object sender, System.EventArgs e)
		{
			saveButton.Select();
		}

		/// <summary>
		/// LZ{^̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		/// <summary>
		/// ۑ{^̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void saveButton_Click(object sender, System.EventArgs e)
		{
			if(HasIllegalNumber())
			{
				MessageBox.Show(
					"IԍɐlȊO͂̕Ă܂B",
					"Nenga#",
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

				return;
			}

			WriteNumberData();
			Close();
		}

		/// <summary>
		/// ׂăNA{^̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void allClearButton_Click(object sender, System.EventArgs e)
		{
			for(int i = 0; i < rankBoxes.Count; i++)
			{
				// ʂ̏擾
				((TextBox)rankBoxes[i]).Text = "";
				((TextBox)numberBoxes[i]).Text = "";
			}
		}
	}
}
