using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text.RegularExpressions;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace NengaSharp
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class MainWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuEdit;
		private System.Windows.Forms.MenuItem menuItemNumberEdit;
		private System.Windows.Forms.ToolBarButton numberEditButton;
		private System.Windows.Forms.Label messageLabel;
		private System.Windows.Forms.TextBox inputBox;
		private System.Windows.Forms.Button checkButton;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuItemVersion;
		private System.Windows.Forms.ToolBar toolBar;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		[System.Runtime.InteropServices.DllImport("user32.dll")] 
		private static extern int MessageBeep(uint n); 
		
		/// <summary>
		/// IԍǗIuWFNg
		/// </summary>
		private LuckyNumbers luckyNumbers = new LuckyNumbers();

		public MainWindow()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			// Iԍǂݍ
			NumberEditDialog dialog = new NumberEditDialog(this);

			// IԍXV
			dialog.UpdateLuckyNumbers();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainWindow));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			this.menuEdit = new System.Windows.Forms.MenuItem();
			this.menuItemNumberEdit = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuItemVersion = new System.Windows.Forms.MenuItem();
			this.toolBar = new System.Windows.Forms.ToolBar();
			this.numberEditButton = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.messageLabel = new System.Windows.Forms.Label();
			this.inputBox = new System.Windows.Forms.TextBox();
			this.checkButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuFile,
																					  this.menuEdit,
																					  this.menuHelp});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemExit});
			this.menuFile.Text = "t@C(&F)";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 0;
			this.menuItemExit.Text = "I(&X)";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// menuEdit
			// 
			this.menuEdit.Index = 1;
			this.menuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemNumberEdit});
			this.menuEdit.Text = "ҏW(&E)";
			// 
			// menuItemNumberEdit
			// 
			this.menuItemNumberEdit.Index = 0;
			this.menuItemNumberEdit.Text = "IԍҏW(&N)...";
			this.menuItemNumberEdit.Click += new System.EventHandler(this.menuItemNumberEdit_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 2;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemVersion});
			this.menuHelp.Text = "wv(&H)";
			// 
			// menuItemVersion
			// 
			this.menuItemVersion.Index = 0;
			this.menuItemVersion.Text = "o[W(&A)...";
			this.menuItemVersion.Click += new System.EventHandler(this.menuItemVersion_Click);
			// 
			// toolBar
			// 
			this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					   this.numberEditButton});
			this.toolBar.DropDownArrows = true;
			this.toolBar.ImageList = this.imageList1;
			this.toolBar.Location = new System.Drawing.Point(0, 0);
			this.toolBar.Name = "toolBar";
			this.toolBar.ShowToolTips = true;
			this.toolBar.Size = new System.Drawing.Size(384, 28);
			this.toolBar.TabIndex = 0;
			this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
			// 
			// numberEditButton
			// 
			this.numberEditButton.ImageIndex = 0;
			this.numberEditButton.ToolTipText = "IԍҏW";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.White;
			// 
			// messageLabel
			// 
			this.messageLabel.Font = new System.Drawing.Font("lr SVbN", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.messageLabel.Location = new System.Drawing.Point(16, 104);
			this.messageLabel.Name = "messageLabel";
			this.messageLabel.Size = new System.Drawing.Size(360, 24);
			this.messageLabel.TabIndex = 1;
			this.messageLabel.Text = "ԍ͂ĂB";
			// 
			// inputBox
			// 
			this.inputBox.Font = new System.Drawing.Font("lr SVbN", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.inputBox.Location = new System.Drawing.Point(16, 56);
			this.inputBox.MaxLength = 20;
			this.inputBox.Name = "inputBox";
			this.inputBox.Size = new System.Drawing.Size(176, 23);
			this.inputBox.TabIndex = 2;
			this.inputBox.Text = "";
			this.inputBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.inputBox_KeyPress);
			// 
			// checkButton
			// 
			this.checkButton.Font = new System.Drawing.Font("lr SVbN", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.checkButton.Location = new System.Drawing.Point(224, 56);
			this.checkButton.Name = "checkButton";
			this.checkButton.Size = new System.Drawing.Size(88, 23);
			this.checkButton.TabIndex = 3;
			this.checkButton.Text = "`FbN";
			this.checkButton.Click += new System.EventHandler(this.checkButton_Click);
			// 
			// MainWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(384, 139);
			this.Controls.Add(this.checkButton);
			this.Controls.Add(this.inputBox);
			this.Controls.Add(this.messageLabel);
			this.Controls.Add(this.toolBar);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Name = "MainWindow";
			this.Text = "Nenga#";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainWindow());
		}

		/// <summary>
		/// IԍҏWj[NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void menuItemNumberEdit_Click(object sender, System.EventArgs e)
		{
			NumberEditDialog dialog = new NumberEditDialog(this);
			dialog.ShowDialog();
		}

		/// <summary>
		/// o[W񃁃j[NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void menuItemVersion_Click(object sender, System.EventArgs e)
		{
			VersionDialog dialog = new VersionDialog();
			dialog.ShowDialog();
		}

		/// <summary>
		/// Ij[NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void menuItemExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		/// <summary>
		/// IԍǗIuWFNgԂ܂B
		/// </summary>
		/// <returns>IԍǗIuWFNg</returns>
		public LuckyNumbers GetLuckyNumbers()
		{
			return luckyNumbers;
		}

		/// <summary>
		/// c[o[̃{^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void toolBar_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if(e.Button == numberEditButton)
			{
				NumberEditDialog dialog = new NumberEditDialog(this);
				dialog.ShowDialog();
			}
		}

		/// <summary>
		/// `FbN{^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void checkButton_Click(object sender, System.EventArgs e)
		{
			CheckRankForNumber();
			inputBox.Select();
		}

		/// <summary>
		/// ͂ꂽԍ`FbN܂B
		/// </summary>
		private void CheckRankForNumber()
		{
			if(luckyNumbers.Count == 0)
			{
				MessageBeep(0);
				messageLabel.Text = "Iԍo^Ă܂B";
				return;
			}

			if(inputBox.Text.Length == 0)
			{
				MessageBeep(0);
				messageLabel.Text = "ԍ͂ĂB";
				return;
			}

			// Iԍɂ݂͐̂e
			Regex regex = new Regex("^[0-9]+$");

			// ȊO̕܂܂Ăꍇ
			if(! regex.IsMatch(inputBox.Text))
			{
				MessageBeep(0);
				messageLabel.Text = "ԍ͔pœ͂ĂB";
				return;
			}

			string rank = luckyNumbers.GetRankForNumber(inputBox.Text);

			if(rank == null)
			{
				messageLabel.Text =	inputBox.Text + "͂͂łB";
			}
			else
			{
				// Nlǂ`FbN
				if(regex.IsMatch(rank))
				{
					// l̏ꍇ́łƕ\
					messageLabel.Text = inputBox.Text + "" + rank + "łB";
				}
				else
				{
					// lȊȌꍇ́łƕ\
					messageLabel.Text = inputBox.Text + "" + rank + "łB";
				}
			}

			inputBox.Text = "";
		}

		/// <summary>
		/// ̓{bNXŃL[ꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void inputBox_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(e.KeyChar == (char)Keys.Enter)
			{
				CheckRankForNumber();
				e.Handled = true;
			}
		}
	}
}
