using System;
using System.Text.RegularExpressions;

namespace NengaSharp
{
	/// <summary>
	/// IԍێNXłB
	/// </summary>
	public class RankAndNumber : IComparable
	{
		/// <summary>
		/// Nł
		/// </summary>
		private string rank;

		/// <summary>
		/// Iԍł
		/// </summary>
		private string number;

		public RankAndNumber()
		{
		}

		public RankAndNumber(string rank, string number)
		{
			Rank = rank;
			Number = number;
		}

		/// <summary>
		/// Nł
		/// </summary>
		public string Rank
		{
			get
			{
				return rank;
			}
			set
			{
				rank = value;
			}
		}

		/// <summary>
		/// Iԍł
		/// </summary>
		public string Number
		{
			get
			{
				return number;
			}
			set
			{
				number = value;
			}
		}
		#region IComparable o

		/// <summary>
		/// ̃IuWFNgƏԂr܂B
		/// </summary>
		/// <param name="obj">rΏۂ̃IuWFNg</param>
		/// <returns>r</returns>
		public int CompareTo(object obj)
		{
			if(! (obj is RankAndNumber))
			{
				return 0;
			}

			RankAndNumber other = (RankAndNumber)obj;

			int result = other.Number.Length - Number.Length;

			if(result == 0)
			{
				// p^[
				Regex regex = new Regex("^[0-9]+$");

				// ǂƂ̏ꍇ
				if(regex.IsMatch(Rank) && regex.IsMatch(other.Rank))
				{
					int thisNumber = Int32.Parse(Rank);
					int otherNumber = Int32.Parse(other.Rank);

					result = thisNumber - otherNumber;
				}
				// ǂƂłȂꍇ
				else if(! regex.IsMatch(Rank) && ! regex.IsMatch(other.Rank))
				{
					result = Rank.CompareTo(other.Rank);
				}
				// rΏۂłȂꍇ
				else if(regex.IsMatch(Rank) && ! regex.IsMatch(other.Rank))
				{
					result = -1;
				}
				// głȂꍇ
				else
				{
					result = 1;
				}
			}

			return result;
		}

		#endregion
	}
}
